# Smart Segments

{% hint style="success" %}
This is the official documentation of the `@forestadmin/agent` Node.js agent.
{% endhint %}

Smart Segments should be quick to migrate, as the syntax is very similar to the legacy agent.

{% hint style="info" %}
You can find the full documentation of segment customization [here](https://docs.forestadmin.com/developer-guide-agents-nodejs/agent-customization/segments).
{% endhint %}

## Code cheatsheet

| Legacy agent    | New agent                                                                                                                                 |
| --------------- | ----------------------------------------------------------------------------------------------------------------------------------------- |
| where:          | handler body                                                                                                                              |
| sequelize.where | [condition tree](https://docs.forestadmin.com/developer-guide-agents-nodejs/data-sources/getting-started/queries/filters#condition-trees) |

## How to migrate

### Structure

Because the new Forest Admin agent is designed to work with multiple databases, the return value of the filter function is not a Sequelize or Mongoose condition anymore.

Instead, you'll be building a [condition tree](https://docs.forestadmin.com/developer-guide-agents-nodejs/data-sources/getting-started/queries/filters#condition-trees) that will be translated to the appropriate database syntax by the agent.

### Performance

All queries cannot be expressed in the Forest Admin query interface, but many can.

You can have great performance improvements by using the Forest Admin query interface to build your conditions, instead of performing the query yourself, and then building a naive condition tree, which filters by primary key like in the example we're providing.

### Example

In this example, we migrate a segment that returns the 5 bestsellers of a product collection.

{% tabs %}
{% tab title="Before" %}

```javascript
collection('products', {
  segments: [
    {
      name: 'Bestsellers',
      where: async product => {
        const query = `
        SELECT products.id, COUNT(orders.*)
        FROM products
        JOIN orders ON orders.product_id = products.id
        GROUP BY products.id
        ORDER BY count DESC
        LIMIT 5;
      `;

        const products = await models.connections.default.query(query, {
          type: QueryTypes.SELECT,
        });

        return { id: { [Op.in]: products.map(product => product.id) } };
      },
    },
  ],
});
```

{% endtab %}

{% tab title="After" %}

```javascript
agent.customizeCollection('products', products => {
  products.addSegment('Bestsellers', async () => {
    const query = `
      SELECT products.id, COUNT(orders.*)
      FROM products
      JOIN orders ON orders.product_id = products.id
      GROUP BY products.id
      ORDER BY count DESC
      LIMIT 5;
    `;

    const products = await models.connections.default.query(query, {
      type: QueryTypes.SELECT,
    });

    return { field: 'id', operator: 'In', value: products.map(p => p.id) };
  });
});
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-nodejs/getting-started/migrating/steps/code-transformations/smart-segments.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
